require 'helper'

module HasVersions
  module Record
    class AttributesTest < MiniTest::Unit::TestCase
      class VersionedRecord < TestRecord
        attr_accessor :name
        attr_accessor :price
        attr_accessor :weight
        attr_accessor :color

        versioning_configuration.attribute :name
        versioning_configuration.attribute :price
        versioning_configuration.attribute :weight
      end

      def test_class_versioned_attributes
        assert_equal ['name', 'price', 'weight'], VersionedRecord.versioned_attributes
      end

      def test_instance_versioned_attributes
        record = VersionedRecord.new(name: 'joe', price: nil, weight: 142.0, color: 'green')
        expected = {'name' => 'joe', 'weight' => '142.0'}

        assert_equal expected, record.versioned_attributes
      end
    end
  end
end