require 'helper'

module HasVersions
  module Record
    class ResetTest < MiniTest::Unit::TestCase
      class ResetRecord < TestRecord
        attr_accessor :name
        attr_accessor :color

        versioning_configuration.attribute :name

        def self.versioning_decode_value(name, value)
          "hello, #{value}"
        end
      end

      def test_from_version
      end

      def test_reset
        reset_model = ResetRecord.new(name: "bob", color: "green")
        version = ResetRecord.version_model.new(snapshot: {name: "joe", color: "blue"})

        reset_model.reset!(version)

        assert_equal "hello, joe", reset_model.name
        assert_equal "green", reset_model.color
      end
    end
  end
end
