require 'helper'

module HasVersions
  class RecordTest < MiniTest::Unit::TestCase
    def test_version_class
      assert_equal TestVersion, TestRecord.version_class
    end

    def test_versioning_configuration
      assert_kind_of HasVersions::Record::Configuration, TestRecord.versioning_configuration
      assert_equal TestRecord.versioning_configuration, TestRecord.new.versioning_configuration
    end

    def test_to_version
      record = Class.new(TestRecord) do
        attr_accessor :name
        versioning_configuration.attribute :name
      end.new(name: 'wee')

      version = record.to_version

      assert_kind_of TestVersion, version
      assert_equal record, version.target
      assert_equal record.versioned_attributes, version.snapshot
    end
  end
end