require 'helper'

module HasVersions
  module Version
    class LogTest < MiniTest::Unit::TestCase

      def test_walk
        grandparent = TestVersion.new
        parent = TestVersion.new parent: grandparent
        child = TestVersion.new parent: parent

        ancestors = []
        child.log.walk do |v|
          ancestors << v
        end

        assert_equal [child, parent, grandparent], ancestors
      end

      def test_all
        grandparent = TestVersion.new
        parent = TestVersion.new parent: grandparent
        child = TestVersion.new parent: parent

        assert_equal [child, parent, grandparent], child.log.all
        assert_equal [child, parent, grandparent], child.log.to_a
      end

      def test_is_enumerable
        assert TestVersion.new.log.respond_to?(:collect)
      end
    end
  end
end