class TestRecord
  include HasVersions::Record
  self.version_class_name = 'TestVersion'

  def initialize(attributes = {})
    @attributes = {}
    attributes.each do |key, value|
      @attributes[key.to_s] = value
      send("#{key}=", value)
    end
  end

  class << self
    def versioning_encode_value(name, value)
      value.to_s
    end

    def versioning_decode_value(name, value)
      value
    end
  end

  def [](attribute)
    @attributes[attribute]
  end
end